from flask import Flask, request
import json

from chat import chat_bot
from decisiontree import calculate
from landanalysis import land_analysis

app = Flask(__name__)

@app.route('/chat_bot', methods=['POST'])
def process_json():
    json = request.json
    print("json data: ", json['message'])
    return {"output" : chat_bot(json['message'])}

@app.route('/decession_tree', methods=['GET'])
def process_json_decission():
    return {"output" : calculate()}

@app.route('/land_analysis', methods=['POST'])
def process_json_land():
    json = request.json
    lat = json['lat']
    long = json['long']
    return {"output" : land_analysis(lat, long)}


if __name__ == '__main__':
    app.run(host='0.0.0.0', port=5000)